//************************************************************************************
//**  
//**  File name:     F:\Microcintrollers\Flowcode projects\labs-flowecode4\4\4.c
//**  Generated by:  Flowcode v4.0.0.53
//**  Date:          Thursday, August 20, 2009 15:09:45
//**  Licence:       Demo
//**  
//**        ***DEMO VERSION***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F887
#define MX_EE
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 4000000

//Configuration data
#pragma DATA 0x2007, 0x3ff4
#pragma DATA 0x2008, 0x3fff

//Internal functions
#include "E:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_Shift();


//Variable declarations
char FCV_LED_OUTPUT;
char FCV_DIRECTION;


//Defines:

/**** Macro Substitutions ****
portb = Port Register
trisb = Data Direction Register
1 = Number Of Switches
10 = Debounce Delay
1 = Switch 0 Pin
0 = Switch 1 Pin
0 = Switch 2 Pin
0 = Switch 3 Pin
0 = Switch 4 Pin
0 = Switch 5 Pin
0 = Switch 6 Pin
0 = Switch 7 Pin
******************************/




//Switches0: //Macro function declarations

void FCD_Switches0_GetMask(char nSwitch, char &nMask);
char FCD_Switches0_ReadState(char WhichSwitch);
void FCD_Switches0_WaitUntilHigh(char WhichSwitch);
void FCD_Switches0_WaitUntilLow(char WhichSwitch);



//Switches0: //Macro implementations


void FCD_Switches0_GetMask(char nSwitch, char &nMask)
{
		switch (nSwitch)
		{
			case 0:
				nMask = 1;
				break;
		  #if (1 > 1)
			case 1:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 2)
			case 2:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 3)
			case 3:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 4)
			case 4:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 5)
			case 5:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 6)
			case 6:
				nMask = 0;
				break;
		  #endif
		  #if (1 > 7)
			case 7:
				nMask = 0;
				break;
		  #endif
			default:
				nMask = 0;
				break;
		}
}

char FCD_Switches0_ReadState(char WhichSwitch)
{
		char SwitchMask = 0;
		FCD_Switches0_GetMask(WhichSwitch, SwitchMask);

		trisb = trisb | SwitchMask;
		return ((portb & SwitchMask) != 0);
}

void FCD_Switches0_WaitUntilHigh(char WhichSwitch)
{
		char SwitchMask = 0;
		FCD_Switches0_GetMask(WhichSwitch, SwitchMask);

		trisb = trisb | SwitchMask;
		nop();
		nop();
		nop();
		nop();
		while ((portb & SwitchMask) == 0);
		Wdt_Delay_Ms(10);
}

void FCD_Switches0_WaitUntilLow(char WhichSwitch)
{
		char SwitchMask = 0;
		FCD_Switches0_GetMask(WhichSwitch, SwitchMask);

		trisb = trisb | SwitchMask;
		nop();
		nop();
		nop();
		nop();
		while ((portb & SwitchMask) != 0);
		Wdt_Delay_Ms(10);
}

//Macro implementations

void FCM_Shift()
{
	//This macro is used to shift the contents of the LED_Output variable by one bit position either Left or Right depending on the state on the direction variable. Prior to any shift, the condition that will result in LED_Output = 0 is checked.  
	
	//Direction check
	//Decision: direction = 1?
	if (FCV_DIRECTION == 1)
	{
		//LED_Output = 0b00000001
		//Decision: LED_Output = 0b00000001?
		if (FCV_LED_OUTPUT == 1)
		{
			//LED_Output = 0b10000000
			//Calculation:
			//  LED_Output = 0b10000000
			FCV_LED_OUTPUT = 128;
			

		} else {
			//LED_Output = LED_Output >> 1
			//Calculation:
			//  LED_Output = LED_Output >> 1
			FCV_LED_OUTPUT = FCV_LED_OUTPUT >> 1;
			

		}


	} else {
		//LED_Output = 0b10000000
		//Decision: LED_Output = 0b10000000?
		if (FCV_LED_OUTPUT == 128)
		{
			//LED_Output = 0b00000001
			//Calculation:
			//  LED_Output = 0b00000001
			FCV_LED_OUTPUT = 1;
			

		} else {
			//LED_Output = LED_Output << 1
			//Calculation:
			//  LED_Output = LED_Output << 1
			FCV_LED_OUTPUT = FCV_LED_OUTPUT << 1;
			

		}


	}


	//IF LED_Output = 0b00000000
	//Decision: LED_Output = 0b00000000?
	if (FCV_LED_OUTPUT == 0)
	{
		//LED_Output = 0b00000001
		//Calculation:
		//  LED_Output = 0b00000001
		FCV_LED_OUTPUT = 1;
		

	}


}

void main()
{
	
	//Initialisation
	ansel = 0;
anselh = 0;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Initialize
	//Calculation:
	//  LED_Output = 0b00000000
	//  direction = 0
	FCV_LED_OUTPUT = 0;
	FCV_DIRECTION = 0;
	

	//Loop
	//Loop: While 1
	while (1)
	{
		//Get_Inputs
		//Call Component Macro: direction=Switches(0)::ReadState(0)
		FCV_DIRECTION = FCD_Switches0_ReadState(0);


		//Call Macro
		//Call Macro: Shift
		FCM_Shift();


		//Do_Outputs
		//Output: LED_Output -> PORT D
		trisd = 0x00;
		portd = FCV_LED_OUTPUT;


		//Delay
		//Delay: 1 s
		delay_s(1);


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
}



