//************************************************************************************
//**  
//**  File name:     F:\Microcintrollers\Flowcode projects\labs-flowecode4\5\5.c
//**  Generated by:  Flowcode v4.0.0.53
//**  Date:          Friday, August 21, 2009 16:17:39
//**  Licence:       Demo
//**  
//**        ***DEMO VERSION***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F887
#define MX_EE
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 4000000

//Configuration data
#pragma DATA 0x2007, 0x3fe4
#pragma DATA 0x2008, 0x3fff

//Internal functions
#include "E:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_INT_ISR();
void FCM_Shift();


//Variable declarations
char FCV_LED_OUTPUT;
char FCV_DIRECTION;



//Macro implementations

void FCM_INT_ISR()
{
	//This macro services the external edge-triggered interrupt. If the pushbutton connected transitions from LOW-to-HIGH triggering an interrupt, the direction bitvariable is toggled.
	
	//Toggle direction variable
	//Calculation:
	//  direction = direction XOR 0b00000001
	FCV_DIRECTION = FCV_DIRECTION ^ 1;
	

}

void FCM_Shift()
{
	//This macro is used to shift the contents of the LED_Output variable by one bit position either Left or Right depending on the state on the direction variable. Prior to any shift, the condition that will result in LED_Output = 0 is checked.  
	
	//Direction check
	//Decision: direction = 1?
	if (FCV_DIRECTION == 1)
	{
		//LED_Output = 0b00000001
		//Decision: LED_Output = 0b00000001?
		if (FCV_LED_OUTPUT == 1)
		{
			//LED_Output = 0b10000000
			//Calculation:
			//  LED_Output = 0b10000000
			FCV_LED_OUTPUT = 128;
			

		} else {
			//LED_Output = LED_Output >> 1
			//Calculation:
			//  LED_Output = LED_Output >> 1
			FCV_LED_OUTPUT = FCV_LED_OUTPUT >> 1;
			

		}


	} else {
		//LED_Output = 0b10000000
		//Decision: LED_Output = 0b10000000?
		if (FCV_LED_OUTPUT == 128)
		{
			//LED_Output = 0b00000001
			//Calculation:
			//  LED_Output = 0b00000001
			FCV_LED_OUTPUT = 1;
			

		} else {
			//LED_Output = LED_Output << 1
			//Calculation:
			//  LED_Output = LED_Output << 1
			FCV_LED_OUTPUT = FCV_LED_OUTPUT << 1;
			

		}


	}


	//IF LED_Output = 0b00000000
	//Decision: LED_Output = 0b00000000?
	if (FCV_LED_OUTPUT == 0)
	{
		//LED_Output = 0b00000001
		//Calculation:
		//  LED_Output = 0b00000001
		FCV_LED_OUTPUT = 1;
		

	}


}

void main()
{
	
	//Initialisation
	ansel = 0;
anselh = 0;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//PB_Interrupt
	//Interrupt: Enable RB0INT
	option_reg.INTEDG=1;
	iocb = iocb | 0x01;
	intcon.GIE=1;
	intcon.INTE=1;


	//Initialize
	//Calculation:
	//  LED_Output = 0b00000000
	//  direction = 1
	FCV_LED_OUTPUT = 0;
	FCV_DIRECTION = 1;
	

	//Loop
	//Loop: While 1
	while (1)
	{
		//Call Macro
		//Call Macro: Shift
		FCM_Shift();


		//Do Output
		//Output: LED_Output -> PORT D
		trisd = 0x00;
		portd = FCV_LED_OUTPUT;


		//Delay
		//Delay: 500 ms
		delay_ms(255);
		delay_ms(245);


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (intcon & (1 << INTF))
	{
		FCM_INT_ISR();
		clear_bit(intcon, INTF);
	}


}



